/*
 * $Id: zxerrstrs.c $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * 	Copyright (c) 1999 Tomi Ollila
 * 	    All rights reserved
 *
 * Created: Sat Jun  5 07:19:21 1999 too
 * Last modified: Fri Jun 18 00:37:46 1999 too
 *
 * HISTORY 
 * $Log: $
 */

#include "zipx_priv.h"

/* FINE TUNE XXX */
static char * zip08errlist[] = {
  /*  0  */ "No error",
  /*  1  */ "Out Of memory",
  /*  2  */ "Failed to open %s",
  /*  3  */ "Failed to fstat %s",
  /*  4  */ "Failed to lseek %s",
  /*  5  */ "Failed to read %s",
  /*  6  */ "Zipfile %s too short",
  /*  7  */ "End of directory header missing",
  /*  8  */ "Directory size too big...",
  /*  9  */ "No such file or directory",
  /* 10  */ "Unsupported compression format"
  /* 11  */ "Inflate error",	    /* add better inflate error handling */
  /* 12  */ "Zipfile corrupted", 
  /* 13  */ "Undefined errstr"
};

static const int errlistsiz = sizeof zip08errlist / sizeof zip08errlist[0] - 1;

char * zip_errstr1(int errcode /*, char ** syserrp */)
{
  if ((unsigned)errcode > errlistsiz)
    errcode = errlistsiz;
  
  /* *syserrp = _syserr_(errcode);  */
  return zip08errlist[errcode];
}

char * zip_errstr(ZipFile * zf /*, char ** syserrp */)
{
  return zip_errstr1(zf->errcode /*, syserrp */);
}

#if 0
static char _syserr_(int err)
{
  switch (err)
  {
    case ZRE_ZF_OPEN:
    case ZRE_ZF_STAT:
    case ZRE_ZF_SEEK:
    case ZRE_ZF_READ:
      return sys_errlist[errno];
  }
  return "";
}
#endif
