/*
 * $Id: zip08stat.c $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * 	Copyright (c) 1999 Tomi Ollila
 * 	    All rights reserved
 *
 * Created: Wed Jun 16 12:16:18 1999 too
 * Last modified: Fri Jun 18 00:28:08 1999 too
 *
 * HISTORY 
 * $Log: $
 */

#include <string.h>

#include "zipx_priv.h"

/*
 * This file copies pieces from zip08file.c and zip08dir.c
 * This library will be broken into smaller pieces to fix this.
 * (or then not, but macros/inline functions rule to keep code consistent)
 */

int zip_stat(ZipFile * zf, char * name, ZipStat * zs, int flags)
{
  struct zipfileinfo * zfi = zf->zfi;
  int (*comprfunc)(const char *, const char *);
  char * n;

  comprfunc = (flags & ZOF_CASEINSENSITIVE)? strcasecmp: strcmp;

  if (flags & ZOF_IGNOREPATH)
  {
    if ((n = strrchr(name, '/')) != NULL)
      name = n + 1;
  }

    if (zfi != NULL)
      while (1)
      {
	if (comprfunc(zfi->fname, name) == 0)
	  break;

	if (zfi->next == 0)
	{
	  zf->errcode = ZRE_ENOENT;
	  return -1;
	}

	(char *)zfi += zfi->next;
      }

    zs->compr = zfi->compr;
    zs->size  = zfi->usize;
    zs->name  = zfi->fname;

    return 0;
}
