/*
 * $Id: zipx_priv.h $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * 	Copyright (c) 1999 Tomi Ollila
 * 	    All rights reserved
 *
 * Created: Sat Jun  5 11:51:37 1999 too
 * Last modified: Wed Jun 16 18:01:21 1999 too
 *
 * HISTORY 
 * $Log: $
 */

#ifndef ZIPX_PRIV_H
#define ZIPX_PRIV_H

#ifdef USE_GLIB_H
#include <glib.h>
#else
#include "varsizes.h"
#endif

/*
 * this structure cannot be wildly enlarged...
 */
struct zipfileinfo
{
  guint32	usize;
  guint32	csize;
  guint32	crc32;
  guint32	offset;	/* offset of file in zipfile */
  guint16	next;	/* next zipfileinfo structure (in linked list)*/
  guint8	compr;
  char		fname[1];
};

struct ZipFp_s;

#define ZipFp struct ZipFp_s
struct ZipFile_s
{
  int fd;
  int refcount;
  ZipFp * zfp;   /* --- reduce a lot of allocations/deallocations by */
  char * buf32k; /* --- caching one entry of these data structures */
  struct zipfileinfo * zfi;
  struct zipfileinfo * zdp; /* zip directpry pointer, for dirent stuff */
  int /* zrerror_t */ errcode;
}; 
#undef ZipFp

#define BUF32KSIZE 32768

guint32 __zip08x_internal_makelong(unsigned char * s);
guint16 __zip08x_internal_makeword(unsigned char * s);

#define makelong(x) __zip08x_internal_makelong(x)
#define makeword(x) __zip08x_internal_makeword(x)

#include "zipx.h"

#endif /* ZIPX_PRIV_H */
